#!/bin/bash
####
#### Call this script with an object and it will produce the change
#### information for all the parents of that object
####
# multiple parents test 1d0f4aec21e5b66c441213643426c770dc6dedc0
# parents: ffa098b2e187b71b86a76d3cd5eb77d074a2503c
# 6860e0d9197c7f52155466c225baf39b42d62f63

# regex for parent declarations
PARENTS="^parent [A-z0-9]{40}$"
TMP=`mktemp`
	
# takes an object and generates the object's parent(s)
unpack_parents () {
	cat-file $1 > $TMP
	echo "me $1" >> ChangeLog
	cat $TMP >> ChangeLog
	echo -e "\n--------------------------\n" >> ChangeLog
	RENTS=`egrep "$PARENTS" $TMP | sed -r s/parent\ //g | xargs echo`

	# if the last object had no parents, return
	if ! egrep -q "$PARENTS" $TMP; then
		return;
	fi

	#useful for testing
	#echo $RENTS
	#read
	for i in `echo $RENTS`; do
		# break cycles
		if grep -q "me $i" ChangeLog; then
			echo "Already visited $i"
			continue
		else
			unpack_parents $i
		fi
	done 
}

unpack_parents $1
rm $TMP
